using Domain;
using Domain.Weapons;
using Domain.XML_Model;
using Infrastructure;
using System.Collections.Generic;

namespace DataLayer;

public static class DbContextInitializer
{
    public static void Initialize(DeathwatchDbContext context, string filepath = null)
    {
        context.Database.EnsureCreated();

        // Look for any students.
        if (context.Players.Any()) return; // DB has been seeded

        var weapon = new Weapon
        {
            At = "test",
            Range = 30,
            Attribute = "CT",
            Type = "RANGE"
        };

        var players = new[]
        {
            new Player
            {
                Experience = 17400,
                CC = 52,
                CT = 40,
                F = 46,
                E = 45,
                AG = 50,
                INT = 34,
                PER = 43,
                FM = 43,
                SOC = 40,
                Weapons = new List<Weapon> { weapon }
            }
        };
        foreach (var player in players) context.Players.Add(player);
        context.SaveChanges();

        SeedDatabase(context, filepath);
    }

    public static void SeedDatabase(DeathwatchDbContext context, string filesPath = null)
    {
        // Define the paths to the XML files

        //string accessoireFilePath = Path.Combine("XML", "Accessoires.xml");
        //string ameliorationFilePath = Path.Combine("XML", "Ameliorations.xml");
        //string extensionFilePath = Path.Combine("XML", "Extensions.xml");
        if (!string.IsNullOrEmpty(filesPath))
        {
            var roots = new List<Root>();
            try
            {
                // Deserialize the XML files
                GetRootsElements(roots, filesPath);
                ExtractFromRoot(context, roots);

            }
            catch (Exception e)
            {
                throw;
            }
        }
    }

    private static void GetRootsElements(List<Root> roots, string filesPath)
    {
        var fileExist = Directory.Exists(filesPath);
        if (!fileExist) return;
        var xmlFiles = Directory.GetFiles(filesPath, "*.xml");

        roots.AddRange(xmlFiles.Select(XmlHelper.DeserializeXmlFile<Root>));
    }

    private static void ExtractFromRoot(DeathwatchDbContext context, List<Root> roots)
    {
        foreach (var root in roots.OfType<Root>())
        {
            if (!context.Accessoires.Any())
                context.Accessoires.AddRange(root.AccessoiresArmes);
            else
            {
                foreach (var item in root.AccessoiresArmes.Where(item => !context.Accessoires.Any(e => e.Id == item.Id)))
                {
                    context.Accessoires.Add(item);
                }
            }

            context.SaveChanges();

            if (!context.Améliorations.Any())
                context.Améliorations.AddRange(root.Améliorations);
            else
            {
                foreach (var item in root.Améliorations.Where(item => !context.Améliorations.Any(e => e.Id == item.Id)))
                {
                    context.Améliorations.Add(item);
                }
            }

            context.SaveChanges();

            if (!context.Archétypes.Any())
                context.Archétypes.AddRange(root.Archétypes);
            else
            {
                foreach (var item in root.Archétypes.Where(item => !context.Archétypes.Any(e => e.Id == item.Id)))
                {
                    context.Archétypes.Add(item);
                }
            }

            context.SaveChanges();

            if (!context.Armes.Any())
                context.Armes.AddRange(root.Armes);
            else
            {
                foreach (var item in root.Armes.Where(item => !context.Armes.Any(e => e.Id == item.Id)))
                {
                    context.Armes.Add(item);
                }
            }

            context.SaveChanges();

            if (!context.Armures.Any())
                context.Armures.AddRange(root.Armures);
            else
            {
                foreach (var item in root.Armures.Where(item => !context.Armures.Any(e => e.Id == item.Id)))
                {
                    context.Armures.Add(item);
                }
            }

            context.SaveChanges();

            if (!context.Assermentations.Any())
                context.Assermentations.AddRange(root.Assermentations);
            else
            {
                foreach (var item in root.Assermentations.Where(item => !context.Assermentations.Any(e => e.Id == item.Id)))
                {
                    context.Assermentations.Add(item);
                }
            }

            context.SaveChanges();

            if (!context.Attributs.Any())
                context.Attributs.AddRange(root.AttributsArmes);
            else
            {
                foreach (var item in root.AttributsArmes.Where(item => !context.Attributs.Any(e => e.Id == item.Id)))
                {
                    context.Attributs.Add(item);
                }
            }

            context.SaveChanges();

            if (!context.Carrières.Any())
                context.Carrières.AddRange(root.Carrières);
            else
            {
                foreach (var item in root.Carrières.Where(item => !context.Carrières.Any(e => e.Id == item.Id)))
                {
                    context.Carrières.Add(item);
                }
            }

            context.SaveChanges();

            if (!context.Competences.Any())
                context.Competences.AddRange(root.Competences);
            else
            {
                foreach (var item in root.Competences.Where(item => !context.Competences.Any(e => e.Id == item.Id)))
                {
                    context.Competences.Add(item);
                }
            }

            context.SaveChanges();

            if (!context.Coordonnées.Any())
                context.Coordonnées.AddRange(root.Coordonnées);
            else
            {
                foreach (var item in root.Coordonnées.Where(item => !context.Coordonnées.Any(e => e.Id == item.Id)))
                {
                    context.Coordonnées.Add(item);
                }
            }

            context.SaveChanges();

            if (!context.Cybernétiques.Any())
                context.Cybernétiques.AddRange(root.Cybernétiques);
            else
            {
                foreach (var item in root.Cybernétiques.Where(item => !context.Cybernétiques.Any(e => e.Id == item.Id)))
                {
                    context.Cybernétiques.Add(item);
                }
            }

            context.SaveChanges();

            if (!context.Disciplines.Any())
                context.Disciplines.AddRange(root.Disciplines);
            else
            {
                foreach (var item in root.Disciplines.Where(item => !context.Disciplines.Any(e => e.Id == item.Id)))
                {
                    context.Disciplines.Add(item);
                }
            }

            context.SaveChanges();

            if (!context.Divinations.Any())
                context.Divinations.AddRange(root.Divinations);
            else
            {
                foreach (var item in root.Divinations.Where(item => !context.Divinations.Any(e => e.Id == item.Id)))
                {
                    context.Divinations.Add(item);
                }
            }

            context.SaveChanges();

            if (!context.Equipements.Any())
                context.Equipements.AddRange(root.Equipements);
            else
            {
                foreach (var item in root.Equipements.Where(item => !context.Equipements.Any(e => e.Id == item.Id)))
                {
                    context.Equipements.Add(item);
                }
            }

            context.SaveChanges();

            if (!context.Implants.Any())
                context.Implants.AddRange(root.Implants);
            else
            {
                foreach (var item in root.Implants.Where(item => !context.Implants.Any(e => e.Id == item.Id)))
                {
                    context.Implants.Add(item);
                }
            }

            context.SaveChanges();

            if (!context.Mondes.Any())
                context.Mondes.AddRange(root.Mondes);
            else
            {
                foreach (var item in root.Mondes.Where(item => !context.Mondes.Any(e => e.Id == item.Id)))
                {
                    context.Mondes.Add(item);
                }
            }

            context.SaveChanges();

            if (!context.Mutations.Any())
                context.Mutations.AddRange(root.Mutations);
            else
            {
                foreach (var item in root.Mutations.Where(item => !context.Mutations.Any(e => e.Id == item.Id)))
                {
                    context.Mutations.Add(item);
                }
            }

            context.SaveChanges();

            if (!context.Pouvoirs.Any())
                context.Pouvoirs.AddRange(root.Pouvoirs);
            else
            {
                foreach (var item in root.Pouvoirs.Where(item => !context.Pouvoirs.Any(e => e.Id == item.Id)))
                {
                    context.Pouvoirs.Add(item);
                }
            }

            context.SaveChanges();

            if (!context.Promotions.Any())
                context.Promotions.AddRange(root.Promotions);
            else
            {
                foreach (var item in root.Promotions.Where(item => !context.Promotions.Any(e => e.Id == item.Id)))
                {
                    context.Promotions.Add(item);
                }
            }

            context.SaveChanges();

            if (!context.Seuils.Any())
                context.Seuils.AddRange(root.SeuilsXp);
            else
            {
                foreach (var item in root.SeuilsXp.Where(item => !context.Seuils.Any(e => e.Id == item.Id)))
                {
                    context.Seuils.Add(item);
                }
            }

            context.SaveChanges();

            if (!context.Sousmondes.Any())
                context.Sousmondes.AddRange(root.Sousmondes);
            else
            {
                foreach (var item in root.Sousmondes.Where(item => !context.Sousmondes.Any(e => e.Id == item.Id)))
                {
                    context.Sousmondes.Add(item);
                }
            }

            context.SaveChanges();

            if (!context.Talents.Any())
                context.Talents.AddRange(root.Talents);
            else
            {
                foreach (var item in root.Talents.Where(item => !context.Talents.Any(e => e.Id == item.Id)))
                {
                    context.Talents.Add(item);
                }
            }

            context.SaveChanges();

            if (!context.Traits.Any())
                context.Traits.AddRange(root.Traits);
            else
            {
                foreach (var item in root.Traits.Where(item => !context.Traits.Any(e => e.Id == item.Id)))
                {
                    context.Traits.Add(item);
                }
            }

            context.SaveChanges();

            if (!context.Troubles.Any())
                context.Troubles.AddRange(root.Troubles);
            else
            {
                foreach (var item in root.Troubles.Where(item => !context.Troubles.Any(e => e.Id == item.Id)))
                {
                    context.Troubles.Add(item);
                }
            }

            context.SaveChanges();

            if (!context.TypeMondes.Any())
                context.TypeMondes.AddRange(root.TypeMondes);
            else
            {
                foreach (var item in root.TypeMondes.Where(item => !context.TypeMondes.Any(e => e.Id == item.Id)))
                {
                    context.TypeMondes.Add(item);
                }
            }

            context.SaveChanges();

            if (!context.TypesNom.Any())
                context.TypesNom.AddRange(root.TypesNom);
            else
            {
                foreach (var item in root.TypesNom.Where(item => !context.TypesNom.Any(e => e.Id == item.Id)))
                {
                    context.TypesNom.Add(item);
                }
            }

            context.SaveChanges();
        }
    }
}